package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementation of the abs-Funktion (modulus)
 */
class ABS extends Funktion
{
/** ABS( f(x) ) = f'(x) * SGN(f(x)) */
public TermBaum ableitung(String variable)
{
	Liste F = new Liste();
	F.addLast( new SGN( getOperand() ) );
	F.addLast( getOperand().ableitung(variable) );
	return new Produkt(F);
} // ableitung()
/** The ABS-Function expects exactly one Parameter */
public final int AnzOperanden(){ return 1; }    
/** Apply the ABS-Funktion to the parameter */
public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
{
	debugC("calculating ABS(" + getOperand().toString() + ")");
	return getOperand().berechne(Variablen, Genauigkeit).abs();
} // berechne()    
/** protected Constructor for the package only ! */
protected ABS(TermBaum T)
{
	super(T);
} // ABS()
/** Constructor needed by 'Funktion' */
protected ABS(){}    
/** Simplifications: ABS(-x) = ABS(x) */
public TermBaum vereinfache()
{
	TermBaum T = getOperand().vereinfache();

	if (T instanceof Negativ)
		// ABS(-a) = ABS(a)
		return new ABS( ((Negativ)T).getOperand() );
	else
		return new ABS(T);
} // vereinfache()
} // class ABS
