package term;

import java.util.StringTokenizer;

/** Tokenize Strings at given characters considering brackets !
 *  Needs brackets to be set correctly, i.e. not like
 *  <code>({)}</code> or <code>({ (( })</code>
 */

public class BracketST extends StringTokenizer
{
	// String-sets of opening and closing brackets
	protected String open, close;

	/** Active position in the parsed String. */
	protected int activePos;
/** Returns the start position of the next Token.
 *  Points beyond the length of the parsed String if there
 *  is no further Token left.
 */
public int getNextPos()
{
	return activePos;
}
public BracketST( String eingabe, String Trenner, String Open, String Close)
{
	super(eingabe, Trenner, true);

	this.open=Open;
	this.close=Close;
	this.activePos = 0;
} // BracketST()    
public Object nextElement()
{
	return this.nextToken();
} // nextElement()    
/** Returns the next Token. Checks the token for the correct number
 *  of opening and closing brackets adding characters until the brackets
 *  are completed.
 */
public String nextToken()
{
	int Klammer=0; // no brackets yet
	StringBuffer next = new StringBuffer();

	// add tokens until the bracket level is the
	// outer most after parsing the token
	do
	{
		int pos = next.length();
		next.append( super.nextToken() );

		// look for opening/closing brackets in the token
		for (int p=pos; p<next.length() && Klammer>=0; p++)
		{
			if (open.indexOf(next.charAt(p)) >= 0)
				Klammer++;
			else if (close.indexOf(next.charAt(p)) >= 0)
				Klammer--;
		}
	}
	while (Klammer > 0 && super.hasMoreTokens());

	activePos += next.length();
	
	return next.toString();
} // nextToken()    
} // class BracketST
