package term;

import java.math.BigDecimal;

/**
 * Insert the type's description here.
 * Creation date: (03.12.1999 %T)
 * @author: 
 */
class COS extends Funktion
{
/**
 * Derivation: cos'(f(x)) = -(f'(x) * sin(f(x))).
 */
public TermBaum ableitung(String variable)
{
	Liste F = new Liste();

	F.addLast( new SIN(getOperand()) );
	F.addLast( getOperand().ableitung(variable) );

	return new Negativ( new Produkt(F) );
}
/**
 * AnzOperanden method comment.
 */
protected final int AnzOperanden() { return 1; }
/**
 * Calculate the COS function by converting the value of the operand
 * into a <code>double</code> and applying the Math.cos() function.
 */
public BigDecimal berechne(VariableTable variables, int genauigkeit)
{
	BigDecimal value = getOperand().berechne(variables, genauigkeit);
	double result = Math.cos( value.doubleValue() );
	return new BigDecimal( result ).setScale(genauigkeit, BigDecimal.ROUND_HALF_UP);
}
/**
 * cloneTerm method comment.
 */
public TermBaum cloneTerm()
{
	return new COS( getOperand().cloneTerm() );
}
	protected COS(TermBaum operand){ super(operand); }
	protected COS(){}
/**
 * vereinfache method comment.
 */
public TermBaum vereinfache()
{
	return new COS( getOperand().vereinfache() );
}
}
