package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implemention of the DIFF-Funktion (derivation)
 * <P>Parameters: (1) Variable, (2) Term</P>
 */
class DIFF extends Funktion
{
public TermBaum ableitung(String variable)
{
	return vereinfache().ableitung(variable);
}    
/** DIFF-Funktion expects two parameters */
protected final int AnzOperanden(){ return 2; }    
/** Calculating the Value of the derivation includes deriving
 *  the term and calculating the result.
 */
public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
{
	return vereinfache().berechne(Variablen, Genauigkeit);
} // berechne()    
// protected Constructor for the package !
protected DIFF(Variable Var, TermBaum Term)
{
	Operanden = new Liste();
	Operanden.addLast(Var);
	Operanden.addLast(Term);
} // DIFF()    
// Constructor for 'Funktion'
protected DIFF(){}    
/** Implements the derivation. */
public TermBaum vereinfache()
{
	Variable Var;

	try
	{
		Var = ((Variable) Operanden.elementAt(0));
	}
	catch (ClassCastException e)
	{
	  throw new TermFaultException("Derivation only in respect to Variables !");
	}

	TermBaum Term = ((TermBaum) Operanden.elementAt(1));

	return Term.vereinfache().ableitung(Var.getName()).vereinfache();
} // vereinfache();    
} // class DIFF
