package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementation of the DIV-Funktion (integer divide)
 */
class DIV extends Funktion
{
public TermBaum ableitung(String variable)
{
	return errorNoDerivation();
}    
  // div-Funktion erwartet genau zwei Parameter
  protected final int AnzOperanden(){ return 2; }    
	/** Applying the DIV-function to the parameters: (a,b) -> a DIV b */
	public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
	{
		BigDecimal f1 = ((TermBaum) Operanden.elementAt(0)).berechne(Variablen, Genauigkeit),
				   f2 = ((TermBaum) Operanden.elementAt(1)).berechne(Variablen, Genauigkeit);

		debugC("calculating DIV("+f1.toString()+","+f2.toString()+")");

		try
		{
			f1 = f1.setScale(0,BigDecimal.ROUND_UNNECESSARY);
			f2 = f2.setScale(0,BigDecimal.ROUND_UNNECESSARY);
		}
		catch (ArithmeticException e)
		{
			throw new TermFaultException("DIV-Function expects integer parameter");
		}

		return f1.divide(f2,BigDecimal.ROUND_DOWN).setScale(Genauigkeit,
													 BigDecimal.ROUND_HALF_UP);
	} // berechne()
	/** protected Constructor nur fuers package */
	protected DIV(TermBaum F, TermBaum Q)
	{
		Operanden = new Liste();
		Operanden.addLast(F);
		Operanden.addLast(Q);
	} // DIV()    
  // Constructor fuer 'Funktion'
  protected DIV(){}      
	// Das Vereinfachen nur zu den Funktionsparametern durchreichen.
	public TermBaum vereinfache()
	{
		TermBaum F = ((TermBaum) Operanden.elementAt(0)).vereinfache();
		TermBaum Q = ((TermBaum) Operanden.elementAt(1)).vereinfache();

		return new DIV(F,Q);
	} // vereinfache();
} // class DIV
