package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementierung der exp-Funktion (natuerliche Exponentialfunktion)
 */
class EXP extends Funktion
{
// Ableitung der exp-Funktion ist exp()
public TermBaum ableitung(String variable)
{
	Liste F = new Liste();
	F.addLast( new EXP( getOperand() ) ); // aeussere mal
	F.addLast( getOperand().ableitung(variable) ); // innere Ableitung

	return (new Produkt(F)).vereinfache();
} // ableitung()    
  // ln-Funktion erwartet genau einen Parameter
  public final int AnzOperanden(){ return 1; }    
/** Anwendung der exp-Funktion auf den Funktionsparameter */
public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
{
	debugC("calculating EXP("+getOperand().toString()+")");

	double D = getOperand().berechne(Variablen, Genauigkeit).doubleValue();

	try
	{
	  return new BigDecimal(Math.exp(D)).setScale(Genauigkeit,
												  BigDecimal.ROUND_HALF_UP);
	}
	catch (NumberFormatException e)
	{
	  throw new TermFaultException("Error calculating LN("+D+")");
	}
} // berechne()
	/** protected Constructor only for the package */
	protected EXP(TermBaum T)
	{
		super(T);
	} // EXP()
  // Constructor fuer 'Funktion'
  protected EXP(){}      
	/** Das Vereinfachen nur zu dem Funktionsparameter durchreichen. */
	public TermBaum vereinfache()
	{
		TermBaum T = getOperand().vereinfache();
		if (T instanceof LN)
		{
			// EXP(LN(a)) = a
			return ((LN)T).getOperand();
		}
		else if (T instanceof Negativ)
		{
			// EXP(-a) = 1/EXP(a)
			return new Kehrwert( ((Negativ)T).getOperand() );
		}
		else
			return new EXP(T);
	} // vereinfache()
} // class EXP
