package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementierung der FAK-Funktion (Fakultaetsfunktion)
 * berechnet (theoretisch) Werte bis (MAX_LONG)!
 */
class FAK extends Funktion{
public TermBaum ableitung(String variable)
{
	return errorNoDerivation();
}    
  // FAK-Funktion erwartet genau einen Parameter
  public final int AnzOperanden(){ return 1; }    
	/** Anwendung der FAK-Funktion auf den Funktionsparameter */
	public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
	{
		BigDecimal wert = getOperand().berechne(Variablen, Genauigkeit);
		debugC("calculating FAK("+wert.toString()+")");

		if (wert.compareTo(BigDecimal.valueOf(0)) == -1)
		  throw new TermFaultException("FAK only applyes to values >= 0");

		try
		{
			wert.setScale(0,BigDecimal.ROUND_UNNECESSARY);
		}
		catch (ArithmeticException e)
		{
		  throw new TermFaultException("FAK only applyes to integers");
		}

		// iterativ die Fakultt bestimmen
		BigDecimal fak = BigDecimal.valueOf(1);

		for(long F = wert.longValue(); F>1; F--)
			fak = fak.multiply( BigDecimal.valueOf(F) );

		return fak.setScale(Genauigkeit, BigDecimal.ROUND_HALF_UP);
	} // berechne()
	/** protected Constructor nur fuers package */
	protected FAK(TermBaum T)
	{
		super(T);
	} // FAK()
  /** Constructor for 'Funktion' */
  protected FAK(){}      
	/** Das Vereinfachen nur zu dem Funktionsparameter durchreichen. */
	public TermBaum vereinfache()
	{
		return new FAK( getOperand().vereinfache() );
	} // vereinfache()
} // class FAK
