package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/**
 * The Termbaum of a constant.
 */
final class Konstante extends TermBaum
{
	/** The value of the constant. */
protected BigDecimal wert;

/** Derivation of a constant function is 0. */
public TermBaum ableitung(String variable)
{
		return new Konstante( BigDecimal.valueOf(0) );
}
/** 'Calculates' the value of this constant. */
public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
{
		return wert.setScale(Genauigkeit, BigDecimal.ROUND_HALF_UP);
}
/** Provides a copy of this Object. */
public TermBaum cloneTerm()
{
	return new Konstante(wert);
}
public boolean isOne()
{
	return wert.compareTo( BigDecimal.valueOf(1) ) == 0;
}
public boolean isZero()
{
	return wert.compareTo( BigDecimal.valueOf(0) ) == 0;
}
public Konstante(String Term, int Offset)
{
	debugP("generating Konstante");

	try{ wert = new BigDecimal(Term); }
	catch (NumberFormatException e)
	{
		throw new TermFaultException(Offset,"Error parsing constant !");
	}
} // Konstante()
/** protected Constructor for clone() */
protected Konstante(BigDecimal D)
{
	wert = D;
}
/** Returns a String representation of this constant. */
public String toString()
{
	return wert.toString();
}
/** There is no way of simplifying a constant function. */
public TermBaum vereinfache()
{
	return this.cloneTerm();
}
} // class Konstante
