package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementierung der MOD-Funktion (Modulo)
 */
class MOD extends Funktion{
public TermBaum ableitung(String variable)
{
	return errorNoDerivation();
}    
  // mod-Funktion erwartet genau zwei Parameter
  protected final int AnzOperanden(){ return 2; }    
/**  Applying the MOD-function to thw parameters: (a,b) -> a mod b */
public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
{
	Enumeration P = Operanden.elements();
	BigDecimal f1 = ((TermBaum)P.nextElement()).berechne(Variablen, Genauigkeit),
			   f2  = ((TermBaum)P.nextElement()).berechne(Variablen, Genauigkeit);

	debugC("calculating MOD("+f1.toString()+","+f2.toString()+")");

	try
	{
		f1.setScale(0,BigDecimal.ROUND_UNNECESSARY);
		f2.setScale(0,BigDecimal.ROUND_UNNECESSARY);
	}
	catch (ArithmeticException e)
	{
		throw new TermFaultException("MOD-Funktion expects integer parameters");
	}

	BigInteger mod;
	try
	{
		mod = f1.toBigInteger().remainder(f2.toBigInteger());
	}
	catch (ArithmeticException e)
	{
		throw new TermFaultException("MOD-Funktion: Division durch 0");
	}

	return new BigDecimal(mod).setScale(Genauigkeit, BigDecimal.ROUND_HALF_UP);
} // berechne()    
	// protected Constructor nur fuers package !
	protected MOD(TermBaum F, TermBaum M)
	{
		Operanden = new Liste();
		Operanden.addLast(F);
		Operanden.addLast(M);
	} // MOD()
  // Constructor fuer 'Funktion'
  protected MOD(){}      
	// Das Vereinfachen nur zu den Funktionsparametern durchreichen.
	public TermBaum vereinfache()
	{
		Enumeration P = Operanden.elements();

		TermBaum F = ((TermBaum)P.nextElement()).vereinfache();
		TermBaum M = ((TermBaum)P.nextElement()).vereinfache();

		return new MOD(F,M);
	} // vereinfache();
} // class MOD
