package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/**
 * Termbaum of a negative sign.
 */
class Negativ extends TermBaum
{

	/** The derivation is the negative derivation of the rest of the Term. */
	public TermBaum ableitung(String variable)
	{
		return new Negativ( operand.ableitung(variable) );
	}
	/** Calculate the Value. */
	public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
	{
		debugC("calculating negative sign for " + operand.toString());
		return operand.berechne(Variablen, Genauigkeit).negate();
	}
	public TermBaum cloneTerm()
	{
		return new Negativ(operand);
	}
	/** Constructor generates a negative Sign for the rest of the Term. */
	public Negativ(String Term, int Offset)
	{
		debugP("generating negative Sign");
		operand = parseTerm(Term, Offset);
	} // Negativ()
	/** protected Constructor for clone() */
	protected Negativ(TermBaum restterm)
	{
		operand = restterm;
	}
	/** Adds a negative sign to the String representation of the rest of the Term. */
	public String toString()
	{
		if (operand instanceof Summe)
			return "-(" + operand.toString() + ")";
		else
			return "-" + operand.toString();
	}
/** -- = +, -0 = 0, ... */
public TermBaum vereinfache()
{
	TermBaum V = operand.vereinfache();
	if (V instanceof Negativ) // -- = +
		return ((Negativ)V).getOperand();
	else if (V instanceof Konstante && ((Konstante)V).isZero())
		return V; // -0 = 0
	else
		return new Negativ(V);
} // vereinfache()
} // class Negativ
