package term;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Enumeration;

/** --------------------------------------------------------------------------
 * Implementierung der sgn-Funktion (Vorzeichenfunktion)
 */
class SGN extends Funktion
{
/** Ableitung der SGN-Funktion ist immer null (idealisiert) */
public TermBaum ableitung(String variable)
{
	return new Konstante( BigDecimal.valueOf(0) );
}    
  // sgn-Funktion erwartet genau einen Parameter
  public final int AnzOperanden(){ return 1; }    
	/** Anwendung der sgn-Funktion auf den Funktionsparameter */
	public BigDecimal berechne(VariableTable Variablen, int Genauigkeit)
	{
		debugC("calculate SGN("+getOperand().toString()+")");
		BigDecimal sign;

		switch ( getOperand().berechne(Variablen, Genauigkeit).signum() )
		{
			case  0:
		 	 	sign = BigDecimal.valueOf( 0);
		 	 	break;
			case -1:
				sign = BigDecimal.valueOf(-1);
				break;
			default:
				sign = BigDecimal.valueOf( 1);
				break;
		}

		return sign.setScale(Genauigkeit, BigDecimal.ROUND_HALF_UP);
	} // berechne()
	// protected Constructor nur fuers package
	protected SGN(TermBaum T)
	{
		super(T);
	} // SGN()    
  // Constructor fuer 'Funktion'
  protected SGN(){}    
	// Das Vereinfachen nur zu dem Funktionsparameter durchreichen.
	public TermBaum vereinfache()
	{
		TermBaum T = getOperand().vereinfache();
		if (T instanceof Negativ)
		{
			// SGN(-a) = -SGN(a)
			return new Negativ( new SGN( ((Negativ)T).getOperand() ) );
		}
		else
			return new SGN(T);
	} // vereinfache()
} // class SGN
