package term;

/** Exception thrown during parsing or calculating a Term/TermBaum.
 *  Includes the error type and position inside the Term string.
 */
public class TermFaultException extends RuntimeException
{
	/** The location where the error occurred in the Term string.
	 *  -1 = unknown
	 */
	protected int Termposition = -1;
/** Builds a new Exception for the specified error at the given location. */
public TermFaultException(int Position, String Fehler)
{
	this(Fehler);
	Termposition  = Position;
}    
/** Short form if the location inside the Term string is unknown. */
public TermFaultException(String Fehler)
{
	super(Fehler);
}    
public String toString(){ return getMessage(); }
public int where(){ return Termposition; }
} // TermFaultException
