package term;

import java.util.*;
import java.math.BigDecimal;

/** A Hashtable to store variable values.
 */
public class VariableTable
{
	private Hashtable hashtable;
/** Adds a new Variable with the given value. */
public void addVariable(String name, BigDecimal value)
{
	addVariable(name, new Konstante(value));
}
/**Enter a new variable with the given Term value or change
 *  the existing value.
 */
public void addVariable(String name, TermBaum value)
{
	if (name != null && value != null)
		hashtable.put(name, value);
}
/** Returns an Enumeration of all variable names stored in the hashtable. */
public Enumeration elements()
{
	return hashtable.keys();
}
/** Returns the value of the variable or null if no value is stored. */
public TermBaum getValue(String name)
{
	return (TermBaum) hashtable.get(name);
}
/** Removes the given variable from the hashtable returning the
 *  old value if it existed (otherwise null).
 */
public TermBaum removeVariable(String name)
{
	return (TermBaum) hashtable.remove(name);
}
/**
 * Constructor builds a new Hashtable.
 */
public VariableTable()
{
	super();
	hashtable = new Hashtable();
}
}
